import fullscreen.*; 
FullScreen fullScreen; 

HandCapture   handCapture;
boolean       drawFlag=false;

import processing.opengl.*;
import processing.pdf.*;
boolean savePDF = false;

float tileCount = 200;
color moduleColor = color(0);
int moduleAlpha = 255;
int actRandomSeed = 0;
int max_distance = 150; 

void setup(){
  size(1024, 768, OPENGL);
  
  handCapture = new HandCapture(this);
  //size(handCapture.width(), handCapture.height());
  
  fullScreen = new FullScreen(this);
  fullScreen.enter();
  
  smooth();
  noCursor();
}

void draw() {
  
  handCapture.update();
  
  //if (savePDF) beginRaw(PDF, timestamp()+".pdf");
  background(255,100);
  fill(255);
  rect(0,0,width,height);
  //noFill();
  

  
  randomSeed(actRandomSeed);

  fill(moduleColor, moduleAlpha);
  strokeWeight(1);
  
  
  
  for (int gridY=0; gridY<width; gridY+=20) {
    for (int gridX=0; gridX<height; gridX+=20) {
      
      PVector handPos = handCapture.handPos();
      PVector mouseVect = new PVector(map(handPos.x, 0, 640, 0, width), map(handPos.y,0,480,0,height));
      
      //mouse 
      //float diameter = dist(mouseX, mouseY, gridX, gridY);
      
      //kinect
      float diameter = dist(mouseVect.x, mouseVect.y, gridX, gridY);
      diameter = diameter/max_distance * 40;
      pushMatrix();
      translate(gridX, gridY, diameter*handPos.z/100);//3.5
      rotate(diameter/100*random(0,10));
      noStroke();
      fill(0);
        rect(-diameter,-diameter, diameter*.25,diameter*2);
      popMatrix(); 
    }
  }
  
}

void keyReleased(){
  if (key == 's' || key == 'S') saveFrame("_##.png");
  if (key == 'p' || key == 'P') savePDF = true;
}




// -----------------------------------------------------------------
// hand events

void onCreateHands(int handId,PVector pos,float time)
{
  handCapture.onCreateHands(handId,pos,time);
}

void onUpdateHands(int handId,PVector pos,float time)
{
  handCapture.onUpdateHands(handId,pos,time);
}

void onDestroyHands(int handId,float time)
{
  handCapture.onDestroyHands(handId,time);
}

void onRecognizeGesture(String strGesture, PVector idPosition, PVector endPosition)
{
  handCapture.onRecognizeGesture(strGesture,idPosition,endPosition);
}

void onProgressGesture(String strGesture, PVector position,float progress)
{
  handCapture.onProgressGesture(strGesture,position,progress);
}






